/***************************************************************************
 *   Copyright (C) 2006 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSKBSASTRODATA_H
#define KBSKBSASTRODATA_H

#include <QDateTime>

#include <kbsastro_export.h>

namespace KBSAstro
{
  KBSASTRO_EXPORT QString formatRA(double ra);
  KBSASTRO_EXPORT QString formatDec(double dec, bool sign=true);
  
  KBSASTRO_EXPORT QDateTime parseJulianDate(double d);
  KBSASTRO_EXPORT QDateTime parseJulianDate(const QString &text);
  KBSASTRO_EXPORT double formatJulianDate(const QDateTime &date);
  
  KBSASTRO_EXPORT QDateTime parseGPSDate(int secs);
  KBSASTRO_EXPORT QDateTime parseGPSDate(const QString &text);
  KBSASTRO_EXPORT int formatGPSDate(const QDateTime &date);
  
  KBSASTRO_EXPORT QDateTime parseSETIClassicDate(const QString &string);
  KBSASTRO_EXPORT QString formatSETIClassicDate(const QDateTime &date);
  KBSASTRO_EXPORT QString formatSETIClassicDate(double date);
}

#endif

