/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSASTROPULSELOGMANAGER_H
#define KBSASTROPULSELOGMANAGER_H

#include <kbslogmanager.h>

#include <kbsastropulse_export.h>

class KBSASTROPULSE_EXPORT KBSAstroPulseLogManager : public KBSLogManager
{
  Q_OBJECT
  public:
    static KBSAstroPulseLogManager *self();
  
  protected:
    KBSAstroPulseLogManager(QObject *parent=0);
     
    virtual unsigned formats() const;
    virtual KBSLogMonitor *createLogMonitor(unsigned format, const KUrl &url, QObject *parent=0);
    
  private:
    static KBSAstroPulseLogManager *s_self;

};

#endif
