/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSCPDNDATA_H
#define KBSCPDNDATA_H

#include <QDomElement>
#include <QStringList>

#include <kbscpdn_export.h>

struct KBSCPDN_EXPORT KBSCPDNUMID
{
  unsigned v,
           md;
  QString n;                // work unit name
  unsigned ph,              // phase
           ts,              // TimeSteps
           day,             // day
           mth,             // month
           yr,              // year
           hr,              // hours
           min,             // minutes
           sec,             // seconds
           csf,             //
           tr,              // TS at the start of the current trickle
           st,              //
           rs,              //
           rsc,             //
           rsdt,            // TS at the start of the current day
           rsmt,            // TS at the start of the current month
           rsyt;            // TS at the start of the current year
  QStringList rsd,
              rsm,
              rsy,
              cs;
  
  bool parse(const QDomElement &node);
};

#endif
