/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSEINSTEINTASKMONITOR_H
#define KBSEINSTEINTASKMONITOR_H

#include <kbstaskmonitor.h>

#include <kbseinstein_export.h>

#include <kbseinsteindata.h>

class KBSEINSTEIN_EXPORT KBSEinsteinTaskMonitor : public KBSTaskMonitor
{
  Q_OBJECT
  public:
    KBSEinsteinTaskMonitor(unsigned task, KBSBOINCMonitor *parent);
    
    virtual const KBSEinsteinState *state() const;

  protected:
    virtual bool parseFile(KBSFileInfo *file, const QString &fileName);
    
    int parseFileName(const QString &fileName) const;
    QString formatFileName(int i) const;
  
  private slots:
    void updateFile(const QString &fileName);
  
  protected:
    KBSEinsteinState m_state;
    KBSEinsteinCmdLineArgs m_args;
    int m_start[2];
};

#endif
