/***************************************************************************
 *   Copyright (C) 2006 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSMOLECULELOG_H
#define KBSMOLECULELOG_H

#include <QWidget>

#include <KDE/KUrl>

#include <kbsmoleculemodel.h>

#include <kbsmolbio_export.h>

class KBSMOLBIO_EXPORT KBSMoleculeLog : public QObject
{
  public:
    enum Format { VRML, X3D };
    
    enum Type { Workunit, Result };
    virtual void log(Type type, const QString &name, const QList<KBSProteinPDB> &pdbs, int id=0) = 0;
    virtual void log(Type type, const QString &name, const KBSProteinFASTA &fasta,
                     const QList<KBSProteinChain> &chains, int id=0) = 0;
  
  protected:
    KBSMoleculeLog(QWidget *parent=0);
    virtual ~KBSMoleculeLog();
  
    virtual void logModel(const KUrl &url, const KBSMoleculeModel &model, Format format);
  
  protected:
    QWidget *m_widget;
  
  private:
    static QString suffix(Format format);
};

#endif
