/***************************************************************************
 *   Copyright (C) 2006 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSMOLECULEWINDOW_H
#define KBSMOLECULEWINDOW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <QEvent>

#include <KDE/KToggleAction>

#include <kbsstandardwindow.h>

#include <kbsmoleculeview.h>

#include <kbsmolbio_export.h>

#ifdef HAVE_GL

class KBSMOLBIO_EXPORT KBSMoleculeWindow : public KBSStandardWindow
{
  Q_OBJECT
  public:
    virtual bool eventFilter(QObject *obj, QEvent *e);
  
  protected:
    KBSMoleculeWindow(QWidget *parent=0);
    
    virtual KBSMoleculeView *selection() const;
    
    virtual QPixmap pixmap();
  
  private slots:
    void activateStyle(int style);
    void activateColoring(int coloring);
  
  private:
    void setupActions();
    void updateActions();
  
  private:
    KBSMoleculeView *m_selection;
    
    KToggleAction *m_style[KBSMoleculeModel::BallAndStick+1];
    KToggleAction *m_coloring[KBSMoleculeModel::CPK+1];
};

#else

class KBSMOLBIO_EXPORT KBSMoleculeWindow : public KBSStandardWindow
{
  Q_OBJECT
  protected:
    KBSMoleculeWindow(QWidget *parent=0) : KBSStandardWindow(parent) {};
};

#endif

#endif
