/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSPANEL_H
#define KBSPANEL_H

#include <QLabel>
#include <QGridLayout>
#include <QEvent>
#include <QMenu>
#include <QStringList>
#include <QWidget>

#include <kbscore_export.h>

class KBSPanelNode;

class KBSCORE_EXPORT KBSPanel : public QWidget
{
  Q_OBJECT
  public:
    KBSPanel(KBSPanelNode *node, QWidget *parent=0);
    
    virtual KBSPanelNode *node() const;
    
    virtual QStringList icons() const;
    virtual void setIcons(const QStringList &icons);
    
    virtual QString header() const;
    virtual void setHeader(const QString &header);
    
    virtual QWidget *content() const;
    virtual void setContent(QWidget *content);
    
    virtual QStringList text() const;
    
    virtual QMenu *contextMenu() const;
    virtual void setContextMenu(QMenu *context);
    virtual bool eventFilter(QObject *obj, QEvent *e);
  
  public slots:
    virtual void editCopy();
  
  protected:
    QStringList m_icons;
    KBSPanelNode *m_node;
    QLabel *m_icon, *m_header;
    QWidget *m_content;
    QMenu *m_context;
  
  private:
    QGridLayout *m_layout;
};

#endif
