/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSSETITASKMONITOR_H
#define KBSSETITASKMONITOR_H

#include <kbstaskmonitor.h>

#include <kbsseti_export.h>

#include <kbssetidata.h>

class KBSSETI_EXPORT KBSSETITaskMonitor : public KBSTaskMonitor
{
  Q_OBJECT
  public:
    KBSSETITaskMonitor(unsigned task, KBSBOINCMonitor *parent);
    virtual ~KBSSETITaskMonitor();
    
    virtual const KBSSETIState *setiState() const;
  
  protected:
    virtual bool parseFile(KBSFileInfo *file, const QString &fileName);
  
  private:
    bool parseStateDocument(const QDomDocument &document);
    void logCalibrationPair();
  
  private slots:
    void updateFile(const QString &fileName);
  
  protected:
    KBSSETIState m_seti;
};

#endif
