/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSSTANDARDWINDOW_H
#define KBSSTANDARDWINDOW_H

#include <QEvent>
#include <QPixmap>

#include <KDE/KXmlGuiWindow>

#include <kbscore_export.h>

class KBSCORE_EXPORT KBSStandardWindow : public KXmlGuiWindow
{
  Q_OBJECT
  public:
    KBSStandardWindow(QWidget *parent=0, Qt::WFlags f=Qt::Window);
    virtual ~KBSStandardWindow();
    
    virtual bool eventFilter(QObject *obj, QEvent *e);
  
  protected:
    virtual void setupActions();
    
    virtual bool queryClose();
    
    virtual QString text();
    virtual QPixmap pixmap();
    
    virtual void setAutoSaveGeometry(const QString &groupName);
  
  private slots:
    void editCopy();
    void fileSave();
  
  private:
    void readGeometry(const QString &groupName);
    void writeGeometry(const QString &groupName);
};

#endif
