/***************************************************************************
 *   Copyright (C) 2004 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSTASKMONITOR_H
#define KBSTASKMONITOR_H

#include <kbscore_export.h>

#include <kbsdatamonitor.h>

class KBSBOINCMonitor;

class KBSCORE_EXPORT KBSTaskMonitor : public KBSDataMonitor
{
  Q_OBJECT
  public:
    virtual QString project() const;
    virtual QString workunit() const;
    virtual QString result() const;
    virtual QString app() const;
    
    virtual unsigned task() const;
    
    virtual KBSBOINCMonitor *boincMonitor();
  
  signals:
    void updatedState();
  
  protected:
    KBSTaskMonitor(unsigned task, KBSBOINCMonitor *parent);
  
  private:
    QString m_app, m_project, m_workunit, m_result;
    unsigned m_task;
};

#endif
