/***************************************************************************
 *   Copyright (C) 2006 by Roberto Virga                                   *
 *   rvirga@users.sourceforge.net                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 ***************************************************************************/

#ifndef KBSWCGDATA_H
#define KBSWCGDATA_H

#include <QDomElement>
#include <QHash>
#include <QStringList>

#include <kbsmolbiodata.h>

#include <kbswcg_export.h>

struct KBSWCG_EXPORT KBSFAAHParameterFile {
  QHash<QString,QString> param;
  
  bool parse(const QStringList &lines);
};

struct KBSWCG_EXPORT KBSFAAHRun {
  unsigned seed[2];
  QString dpf;
  double free_energy_binding,
         ki,
         temp,
         final_intermol_energy,
         internal_ligand_energy,
         torsional_free_energy;
  QString move;
  double about[3],
         tran0[3],
         quat0[3];
  QList<double> dihe0;
  
  bool parse(const QDomElement &element);
};

struct KBSWCG_EXPORT KBSFAAHRuns {
  QList<KBSFAAHRun> run;
  
  bool parse(const QDomElement &element);
};

struct KBSWCG_EXPORT KBSFAAHAutoDock {
  double version,
         autogrid_version,
         output_xml_version;
  unsigned run_requested;
  KBSFAAHRuns runs;
  
  bool parse(const QDomElement &element);
};

struct KBSWCG_EXPORT KBSFAAHResult {
  KBSFAAHParameterFile dpf, gpf;
  KBSProteinPDB molecule, ligand;
  KBSFAAHAutoDock autodock;
};

#endif
